Config

## Classes

class | scim::ConfigError
| An exception class to hold Config related errors. More...
class | scim::ConfigBase
| The interface class to access the configuration data. More...
class | scim::DummyConfig
| A dummy implementation of interface class scim::ConfigBase. More...
class | scim::ConfigModule
| The class to manipulate the config modules. More...

## Macros

#define | SCIM_CONFIG_UPDATE_TIMESTAMP "/UpdateTimeStamp"
#define | SCIM_CONFIG_DEFAULT_IMENGINE_FACTORY "/DefaultIMEngineFactory"
#define | SCIM_CONFIG_FRONTEND_ON_THE_SPOT "/FrontEnd/OnTheSpot"
#define | SCIM_CONFIG_FRONTEND_SHARED_INPUT_METHOD "/FrontEnd/SharedInputMethod"
#define | SCIM_CONFIG_FRONTEND_IM_OPENED_BY_DEFAULT "/FrontEnd/IMOpenedByDefault"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND "/Hotkeys/FrontEnd"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND_TRIGGER "/Hotkeys/FrontEnd/Trigger"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND_ON "/Hotkeys/FrontEnd/On"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND_OFF "/Hotkeys/FrontEnd/Off"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND_NEXT_FACTORY "/Hotkeys/FrontEnd/NextFactory"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND_PREVIOUS_FACTORY "/Hotkeys/FrontEnd/PreviousFactory"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND_SHOW_FACTORY_MENU "/Hotkeys/FrontEnd/ShowFactoryMenu"
#define | SCIM_CONFIG_HOTKEYS_FRONTEND_VALID_KEY_MASK "/Hotkeys/FrontEnd/ValidKeyMask"
#define | SCIM_CONFIG_HOTKEYS_IMENGINE "/Hotkeys/IMEngine"
#define | SCIM_CONFIG_HOTKEYS_IMENGINE_LIST "/Hotkeys/IMEngine/List"
#define | SCIM_CONFIG_FILTER_FILTERED_IMENGINES "/Filter/FilteredIMEngines"
#define | SCIM_CONFIG_FILTER_FILTERED_IMENGINES_LIST "/Filter/FilteredIMEngines/List"
#define | SCIM_GLOBAL_CONFIG_DISABLED_IMENGINE_FACTORIES "/DisabledIMEngineFactories"
#define | SCIM_GLOBAL_CONFIG_SUPPORTED_UNICODE_LOCALES "/SupportedUnicodeLocales"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_KEYBOARD_LAYOUT "/DefaultKeyboardLayout"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_PANEL_PROGRAM "/DefaultPanelProgram"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_CONFIG_MODULE "/DefaultConfigModule"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_FRONTEND_ADDRESS "/DefaultSocketFrontEndAddress"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_IMENGINE_ADDRESS "/DefaultSocketIMEngineAddress"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_CONFIG_ADDRESS "/DefaultSocketConfigAddress"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_PANEL_SOCKET_ADDRESS "/DefaultPanelSocketAddress"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_HELPER_MANAGER_SOCKET_ADDRESS "/DefaultHelperManagerSocketAddress"
#define | SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_TIMEOUT "/DefaultSocketTimeout"

## Typedefs

typedef Pointer< ConfigBase > | scim::ConfigPointer
typedef Slot1< void, const ConfigPointer & > | scim::ConfigSlotVoid
typedef Signal1< void, const ConfigPointer & > | scim::ConfigSignalVoid
typedef void(* | scim::ConfigModuleInitFunc) (void)
| The prototype of initialization function in config modules.
typedef ConfigPointer(* | scim::ConfigModuleCreateConfigFunc) ()
| The prototype of configure object creation function in config modules.

## Functions

int | scim::scim_get_config_module_list (std::vector< String > &mod_list)
| Get a name list of currently available configuration modules.

## Detailed Description

The base classes for config modules

## Macro Definition Documentation

## SCIM_CONFIG_UPDATE_TIMESTAMP

#define SCIM_CONFIG_UPDATE_TIMESTAMP "/UpdateTimeStamp"

## SCIM_CONFIG_DEFAULT_IMENGINE_FACTORY

#define SCIM_CONFIG_DEFAULT_IMENGINE_FACTORY "/DefaultIMEngineFactory"

## SCIM_CONFIG_FRONTEND_ON_THE_SPOT

#define SCIM_CONFIG_FRONTEND_ON_THE_SPOT "/FrontEnd/OnTheSpot"

## SCIM_CONFIG_FRONTEND_SHARED_INPUT_METHOD

#define SCIM_CONFIG_FRONTEND_SHARED_INPUT_METHOD "/FrontEnd/SharedInputMethod"

## SCIM_CONFIG_FRONTEND_IM_OPENED_BY_DEFAULT

#define SCIM_CONFIG_FRONTEND_IM_OPENED_BY_DEFAULT "/FrontEnd/IMOpenedByDefault"

## SCIM_CONFIG_HOTKEYS_FRONTEND

#define SCIM_CONFIG_HOTKEYS_FRONTEND "/Hotkeys/FrontEnd"

## SCIM_CONFIG_HOTKEYS_FRONTEND_TRIGGER

#define SCIM_CONFIG_HOTKEYS_FRONTEND_TRIGGER "/Hotkeys/FrontEnd/Trigger"

## SCIM_CONFIG_HOTKEYS_FRONTEND_ON

#define SCIM_CONFIG_HOTKEYS_FRONTEND_ON "/Hotkeys/FrontEnd/On"

## SCIM_CONFIG_HOTKEYS_FRONTEND_OFF

#define SCIM_CONFIG_HOTKEYS_FRONTEND_OFF "/Hotkeys/FrontEnd/Off"

## SCIM_CONFIG_HOTKEYS_FRONTEND_NEXT_FACTORY

#define SCIM_CONFIG_HOTKEYS_FRONTEND_NEXT_FACTORY "/Hotkeys/FrontEnd/NextFactory"

## SCIM_CONFIG_HOTKEYS_FRONTEND_PREVIOUS_FACTORY

#define SCIM_CONFIG_HOTKEYS_FRONTEND_PREVIOUS_FACTORY "/Hotkeys/FrontEnd/PreviousFactory"

## SCIM_CONFIG_HOTKEYS_FRONTEND_SHOW_FACTORY_MENU

#define SCIM_CONFIG_HOTKEYS_FRONTEND_SHOW_FACTORY_MENU "/Hotkeys/FrontEnd/ShowFactoryMenu"

## SCIM_CONFIG_HOTKEYS_FRONTEND_VALID_KEY_MASK

#define SCIM_CONFIG_HOTKEYS_FRONTEND_VALID_KEY_MASK "/Hotkeys/FrontEnd/ValidKeyMask"

## SCIM_CONFIG_HOTKEYS_IMENGINE

#define SCIM_CONFIG_HOTKEYS_IMENGINE "/Hotkeys/IMEngine"

## SCIM_CONFIG_HOTKEYS_IMENGINE_LIST

#define SCIM_CONFIG_HOTKEYS_IMENGINE_LIST "/Hotkeys/IMEngine/List"

## SCIM_CONFIG_FILTER_FILTERED_IMENGINES

#define SCIM_CONFIG_FILTER_FILTERED_IMENGINES "/Filter/FilteredIMEngines"

## SCIM_CONFIG_FILTER_FILTERED_IMENGINES_LIST

#define SCIM_CONFIG_FILTER_FILTERED_IMENGINES_LIST "/Filter/FilteredIMEngines/List"

## SCIM_GLOBAL_CONFIG_DISABLED_IMENGINE_FACTORIES

#define SCIM_GLOBAL_CONFIG_DISABLED_IMENGINE_FACTORIES "/DisabledIMEngineFactories"

## SCIM_GLOBAL_CONFIG_SUPPORTED_UNICODE_LOCALES

#define SCIM_GLOBAL_CONFIG_SUPPORTED_UNICODE_LOCALES "/SupportedUnicodeLocales"

## SCIM_GLOBAL_CONFIG_DEFAULT_KEYBOARD_LAYOUT

#define SCIM_GLOBAL_CONFIG_DEFAULT_KEYBOARD_LAYOUT "/DefaultKeyboardLayout"

## SCIM_GLOBAL_CONFIG_DEFAULT_PANEL_PROGRAM

#define SCIM_GLOBAL_CONFIG_DEFAULT_PANEL_PROGRAM "/DefaultPanelProgram"

## SCIM_GLOBAL_CONFIG_DEFAULT_CONFIG_MODULE

#define SCIM_GLOBAL_CONFIG_DEFAULT_CONFIG_MODULE "/DefaultConfigModule"

## SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_FRONTEND_ADDRESS

#define SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_FRONTEND_ADDRESS "/DefaultSocketFrontEndAddress"

## SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_IMENGINE_ADDRESS

#define SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_IMENGINE_ADDRESS "/DefaultSocketIMEngineAddress"

## SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_CONFIG_ADDRESS

#define SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_CONFIG_ADDRESS "/DefaultSocketConfigAddress"

## SCIM_GLOBAL_CONFIG_DEFAULT_PANEL_SOCKET_ADDRESS

#define SCIM_GLOBAL_CONFIG_DEFAULT_PANEL_SOCKET_ADDRESS "/DefaultPanelSocketAddress"

## SCIM_GLOBAL_CONFIG_DEFAULT_HELPER_MANAGER_SOCKET_ADDRESS

#define SCIM_GLOBAL_CONFIG_DEFAULT_HELPER_MANAGER_SOCKET_ADDRESS "/DefaultHelperManagerSocketAddress"

## SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_TIMEOUT

#define SCIM_GLOBAL_CONFIG_DEFAULT_SOCKET_TIMEOUT "/DefaultSocketTimeout"

## Typedef Documentation

## ConfigPointer

typedef Pointer<ConfigBase> scim::ConfigPointer

A smart pointer for scim::ConfigBase and its derived classes.

## ConfigSlotVoid

typedef Slot1<void, const ConfigPointer &> scim::ConfigSlotVoid

The slot type to connect to the coresponding signal.

## ConfigSignalVoid

typedef Signal1<void, const ConfigPointer &> scim::ConfigSignalVoid

The signal type to connect with the ConfigSlotVoid slot type.

## ConfigModuleInitFunc

typedef void(* scim::ConfigModuleInitFunc) (void)

The prototype of initialization function in config modules.

There must be a function called "scim_config_module_init" which complies with this prototype. This function name can have a prefix like simple_LTX_, in which "simple" is the module's name.

## ConfigModuleCreateConfigFunc

typedef ConfigPointer(* scim::ConfigModuleCreateConfigFunc) ()

The prototype of configure object creation function in config modules.

There must be a function called "scim_config_module_create_config" which complies with this prototype. This function name can have a prefix like simple_LTX_, in which "simple" is the module's name.

## Function Documentation

## scim_get_config_module_list()

int scim::scim_get_config_module_list | ( | std::vector< String > & | mod_list | ) |

Get a name list of currently available configuration modules.

Parameters

  mod_list | - the result list will be stored here.

Returns
  the number of the modules, equal to mod_list.size ().